#! /usr/bin/perl
#

# Переменные

# Путь до GPSBabel
$gpsbabel = "/usr/bin/gpsbabel";

# Временные файлы для конвертации
$tmp_ps_1 = "/tmp/gpspts_ps_1.csv";
$tmp_ps_0 = "/tmp/gpspts_ps_0.csv";
$tmp_result = "/tmp/temp_result.csv";
$tmp_doubles = "/tmp/temp_doubles.csv";

# Главное меню.
print "Привет!\n";
print "Я помогу тебе переколбасить точки, скачанные с http://mapcam.info\n";

while () {
	print "Выбери действие:\n";
	print "1. Обработать gpx файл\n";
	print "2. Отобрать точки по ключевому слову (во внешнем файле)\n";
	# Пока нет исходных данных - обрабатывать нечего!
	if ($gpx_done == 1) {
		print "3. Отобрать точки по ключевому слову (в загруженных точках)\n";
		print "4. Отсортировать точки по имени-скорости\n";
		print "5. Сохранить отчет о дублях\n";
	} else {
		print "--------- - Остальные дейтсвия пока не доступны - мне тупо не с чем работать!\n";
	}
	print "q. Выход\n";
	print "Введи номер нужного пункта и нажми Enter.\n";

	# Читаем ввод пользователя
	chomp($choise = <STDIN>);
	# Выходим если это "q"
	last if ($choise eq "q");

	# Если это "1" - обрабатываем файл gpx
	if ($choise == 1) {
		$gpx_done = do_gpx();
	}
	# Если это "2" - обрабатываем файл gpx
	if ($choise == 2) {
		do_search_outside();
	}
	# Если это "3" - проверяем, есть ли исходные данные и запускаем выборку.
	if (($gpx_done == 1) && ($choise == 3)) {
		do_search_inside();
	}	
	# Если это "4" - проверяем, есть ли исходные данные и запускаем сортировку.
	if (($gpx_done == 1) && ($choise == 4)) {
		do_sort();
	}
	# Если это "5" - проверяем, есть ли исходные данные и запускаем сортировку.
	if (($gpx_done == 1) && ($choise == 5)) {
		do_print_doubles();
	}
}

# Подчищаем перед выходом...

unlink $tmp_ps_1;
unlink $tmp_ps_0;


sub do_print_doubles {
# Распечатывает дубли.

	while () {

		print "Вводи куда сохранять дубли (или q чтобы вернуться)\n";
		chomp($cho = <STDIN>);
		last if ($cho eq "q");
		open (DOUB,">$cho") || die "Error: $!";
		foreach $geo (sort keys %double_points) {
			$Dirty_names = $double_points{$geo};
			$Dirty_names =~ s/^\s*\+\s//;
			@names = (split /\+/, $Dirty_names);
			
			foreach $name (@names) {
				$name =~ s/^\s*(\d+).*/$1/;
				if ($short_doub{$geo} =~ m/.*$name.*/) {
					++$tribles{$geo};
				} else {
					if ($short_doub{$geo} ne undef) {
						$short_doub{$geo} = "$short_doub{$geo}".","."$name";
					} else {
						$short_doub{$geo} = $name;
					}
				}

			}
				
		}			
		
		foreach $geo (sort keys %short_doub) {
			print DOUB "$geo,$short_doub{$geo}\n";
		}
		close (DOUB);
		$doubles_saved = wpts_in_csv ($cho);
		print "$doubles_saved дублей сохранено в файле $cho\n";
	}
}

sub do_sort {
	print "Сортирую...\n";
	foreach $geo (sort keys %full) {
		@namecom = split(/,/, $full{$geo});
		$Name = $namecom[0];
		$Name =~ s/^\s*\d*_//;
		$Name =~ s/ /_/g;
		$Name =~ s/\//-/g;
		$Name =~ s/\\/-/g;
		$Name = $Name.".csv";
		open (TEMP,">>$Name") || die "Error: $Name -  $!";
		print TEMP "$geo,$full{$geo}\n";
		delete $full{$geo};
		close (TEMP);
		++$files{$Name};
	}
	
	system ("sleep 10s");
	foreach $Name (sort keys %files) {
		print "В файл $Name записано $files{$Name} точек\n";
	}
}

sub do_search_inside {
	

	while () {

		print "Вводи строку поиска (или q чтобы вернуться)\n";
		chomp($ch = <STDIN>);
		last if ($ch eq "q");
		print "Вводи имя файла куда сохранить выборку\n";
		chomp($result = <STDIN>);
	
		open (RESULT,">$result") || die "Не могу открыть файл $result для записи $!";

		foreach $geo (sort keys %full) {
			@namecom = split(/,/, $full{$geo});
			$Comment = $namecom[1];
		
			if ($Comment =~ m/.*$ch.*/gi) {
				print RESULT "$geo,$full{$geo}\n";
				delete $full{$geo};
			} 
		}
		close (RESULT) || die "Error: $!";

		$Waypoints_sorted = wpts_in_csv ($result);
		$Waypoints_left = (keys(%full));
		print "$Waypoints_sorted точек выбрано в файл $result, осталось несортированных $Waypoints_left точек.\n";
	}
}

sub do_search_outside {

my $tmp_file = "/tmp/tmp_sort_file";	

	while () {

		print "Вводи имя файла для поиска (или q чтобы вернуться)\n";
		chomp($read_file = <STDIN>);
		last if ($read_file eq "q");
		print "Вводи строку поиска \n";
		chomp($search_value = <STDIN>);
		print "Вводи имя файла куда сохранить выборку\n";
		chomp($result = <STDIN>);
	
		open (RESULT,">$result") || die "Не могу открыть файл $result для записи $!";
		open (LEFT,">$tmp_file") || die "Error: $!";	
		open (READF,$read_file) || die "Error: $!";
		while (<READF>) {
			($geo_1,$geo_2,$Name,$Comment) = (split /,/)[0, 1, 2, 3];
			chomp ($Comment);
			if ($Comment =~ m/.*$search_value.*/i) {
				print RESULT "$geo_1,$geo_2,$Name,$Comment\n";
			} else {
				print LEFT "$geo_1,$geo_2,$Name,$Comment\n";
			}
		}		
		close (READF);
		close (RESULT);
		close (LEFT);
		
		unlink $read_file;

		system ("cp $tmp_file \"$read_file\"");
		unlink $tmp_file;
		$Waypoints_sorted = wpts_in_csv ($result);
		$Waypoints_left = wpts_in_csv ($read_file);
		print "$Waypoints_sorted точек выбрано в файл $result, осталось несортированных $Waypoints_left точек в файле $read_file.\n";
	}
}


# Обработка gpx файла
sub do_gpx {

	# Читаем имя файла
	print "Вводи имя gpx файла!\n";
	chomp($gpx_file = <STDIN>);
	
	# Проверяем существует ли введенный файл	
	if (-e $gpx_file) {
		# Файл существует
		print "Обрабатываю файл....\n";
		# Считаем кол-во точек в gpx файле.
		$Waypoints_in_source = wpts_in_gpx($gpx_file);

		# Обрабатываем его в gpsbabel.
		# Нам нужно "разобрать" gpx файл на 2 csv файла, в одном из которых будут координаты и название точек,
		# а в другом - координаты и комментарии.

		# Имена
		system("$gpsbabel -w -i gpx -c UTF-8 -f $gpx_file -o csv,prefer_shortnames=1 -c UTF-8 -F $tmp_ps_1");

		# Комментарии
		system("$gpsbabel -w -i gpx -c UTF-8 -f $gpx_file -o csv,prefer_shortnames=0 -c UTF-8 -F $tmp_ps_0");

		# Сливаем обе полученные csv'шки в одну, попутно обрабатываем дубли и собираем их в отдельный файл.
		
			# Открываем для чтения файл с именами
			open (NAMES, $tmp_ps_1) || die "Can't open file $tmp_ps_1: $!";
			while (<NAMES>) {
				# Берем строку, и вынимаем из нее координаты, имя.
				($geo_1, $geo_2, $Name) = (split /,/)[0, 1, 2];
		
				# Делаем небольшую обработку	
				chomp ($Name);
				$geo_1 =~ s/\s//g;
				$geo_2 =~ s/\s//g;
				# Складываем координаты в одну переменную.
				$geo = "$geo_1".","."$geo_2";

				# Если в хеше уже лежит точка с такими координатами - нужно пометить текущую точку как дубль
				if ($points{$geo} eq undef) {
					# Если точки в хеше еще нет - кладем ее туда
					$points{$geo} = $Name;
				} else {
					# Если точка в хеше уже есть - кладем ее в дубли
					$double_points{$geo} = $double_points{$geo}."+".$points{$geo}."+".$Name;
				}

			}
			# Закрываем файл
			close (NAMES) || die "Error closing file: $!";	
			# Обнуляем переменную $geo (нафига - сам не знаю, но пусть будет =)
			$geo = undef;

			# Открываем для чтения файл с комментариями
			open (COMMENTS, $tmp_ps_0) || die "Can't open file $tmp_ps_0: $!";
			while (<COMMENTS>) {
				($geo_1, $geo_2, $Comment) = (split /,/)[0, 1, 2];
				chomp ($Comment);
				$geo_1 =~ s/\s//g;
				$geo_2 =~ s/\s//g;
				$geo = "$geo_1".","."$geo_2";
				
				# Получаем из хеша points имя для этих координат
				$Name = $points{$geo};
				# Собираем строку "Имя,Комментарий"
				$Full = "$Name".","."$Comment";
				# Кладем то, что получилось в новый хеш
				# "Координата,Координата" - "Имя,Комментарий"
				$full{$geo} = $Full;

			}
			# Закрываем файл с комментами
			close (COMMENTS) || die "Error closing file: $!";
			# Обнуляем переменную $geo (нафига - сам не знаю, но пусть будет =) 
			$geo = undef;

		# Итого получили 2 хеша:
		# %full - [координата,координата] - [имя,комментарий]
		# и 
		# %double_points - [координата,координата] - [имя+имя1+....+имяN]
	

		# Считаем кол-во точек в полученных хешах.
		$Waypoints_in_result = (keys(%full));
		$Waypoints_in_doubles = (keys(%double_points));

		# Печатаем отчет
		print "Всего точек - $Waypoints_in_source, из них обработано $Waypoints_in_result как точки и $Waypoints_in_doubles как дубли\n";

		# Выходим
		return 1;

	} else {

		# Файл не существует
		print "Что-то как-то не получается у меня =(\n";

		# Выходим
		return 0;
	}

}


sub wpts_in_csv {
# Считает кол-во точек в csv файле

	# Берем имя файла из аргумента
	my ($filename) = @_;

	# Обнуляем счетчик
	my $total = 0;

	# Открываем файл
	open (CSVFILE,$filename);
	while (<CSVFILE>) {
		# Берем из строки координату
		($geo_1) = (split /,/)[0];
		# Убираем из нее пробелы
		$geo_1 =~ s/\s//g;
		# Проверяем - должно быть число вида: 11.22222
		if ($geo_1 =~ m/\d\d\.\d\d\d\d\d/g) {
			# Если это так - то это точка - крутим счетчик
			++$total;
		}
	}
	# Закрываем файл
	close (CSVFILE);
	# Возвращаем кол-во точек.
	return  $total;
}

sub wpts_in_gpx {
# Считает кол-во точек в gpx файле

	# Берем имя файла из аргумента
	my ($filename) = @_;

	# Обнуляем счетчик
	my $total = 0;

	# Открываем файл
	open (GPXFILE,$filename);
	while (<GPXFILE>) {
		# Если в строке есть "<wpt" - то это точка, крутим счетчик.
		if ($_ =~ m/.*<wpt.*/g) {
			++$total;
		}
	}
	# Закрываем файл
	close (GPXFILE);
	
	# Возвращаем кол-во точек.
	return  $total;
}
